#pragma once

class CDIBSection
{
public:
	CDIBSection(void);
	~CDIBSection(void);

	int CreatePalette();
	void Close(void);
	void Create(int cx, int cy, int nbits ) ;
	void Draw(CDC* pdcDest, int x, int y) ;
	void SetPalette(CPalette* pPal) ;

	CDC* GetDC() {return m_pdc;}
	HBITMAP GetHandle() 
	{
		HBITMAP h = m_hbmp;
		return h;
	}

	unsigned long Width(void)const{ return m_size.cx;}
	unsigned long Height(void)const{ return m_size.cy;}
	unsigned long GetTotalWidth(void)const{ return m_total_width;}
	void * GetBits(void){ return m_pBits;}
	BITMAPINFOHEADER& GetBIH(void){ return m_bih;}

	void InitObject(void);
	void* m_pBits;

protected:
	CPalette m_Palette;
	HBITMAP m_hbmp;
	HBITMAP m_hbmOld;
	CSize m_size;
	CDC* m_pdc;
	int m_total_width;
	BITMAPINFOHEADER m_bih;
};
